"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defaultParserInterface = _interopRequireDefault(require("@astql/core/utils/defaultParserInterface"));

var _package = _interopRequireDefault(require("vue-eslint-parser/package.json"));

var ID = 'vue-eslint-parser';

var _default = (0, _extends2["default"])({}, _defaultParserInterface["default"], {
  id: ID,
  displayName: ID,
  version: _package["default"].version,
  homepage: _package["default"].homepage,
  locationProps: new Set(['start', 'end']),
  typeProps: new Set(['tag']),
  loadParser: function loadParser(callback) {
    new Promise(function (resolve) {
      return resolve(['vue-eslint-parser'].map(function (mdl) {
        return require(mdl);
      }));
    }).then(callback);
  },
  parse: function parse(parser, code, options) {
    if (Object.keys(options).length === 0) {
      options = this.getDefaultOptions();
    }

    return parser.parse(code, options);
  },
  nodeToRange: function nodeToRange(node) {
    if (node.type || node.name) {
      return node.range;
    }
  },
  opensByDefault: function opensByDefault(node, key) {
    return key === 'children';
  },
  getNodeName: function getNodeName(node) {
    return node.tag;
  },
  getDefaultOptions: function getDefaultOptions() {
    return {
      ecmaVersion: 10,
      sourceType: 'module',
      vueFeatures: {
        filter: true,
        interpolationAsNonHTML: false
      }
    };
  },
  _getSettingsConfiguration: function _getSettingsConfiguration() {
    var defaultOptions = this.getDefaultOptions();
    return {
      fields: [['ecmaVersion', [3, 5, 6, 7, 8, 9, 10, 11], function (value) {
        return Number(value);
      }], ['sourceType', ['script', 'module']], {
        key: 'vueFeatures',
        title: 'vueFeatures',
        fields: Object.keys(defaultOptions.vueFeatures),
        settings: function settings(_settings) {
          return _settings.vueFeatures || (0, _extends2["default"])({}, defaultOptions.vueFeatures);
        }
      }]
    };
  },
  _ignoredProperties: new Set(['parent', 'tokens'])
});

exports["default"] = _default;